package org.test;

import javax.inject.Named;
import org.apache.camel.Exchange;
import org.switchyard.bus.camel.processors.Processors;
import org.switchyard.bus.camel.audit.Audit;
import org.switchyard.bus.camel.audit.Auditor;
import org.switchyard.HandlerException;

@Audit({Processors.PROVIDER_CALLBACK})
@Named("Error handler")
public class ErrorHandler implements Auditor {
 
    @Override
    public void beforeCall(Processors processor, Exchange exchange) {
      System.out.println("before");
    }
 
    @Override
    public void afterCall(Processors processor, Exchange exchange) {
      System.out.println("after");
    	org.switchyard.Exchange syEx = exchange.getProperty(org.switchyard.bus.camel.ExchangeDispatcher.SY_EXCHANGE,
    						org.switchyard.Exchange.class);
    	Object contents = syEx.getMessage().getContent();

    	if (contents instanceof HandlerException
    			&& !(contents instanceof org.switchyard.component.bpel.BPELFault)) {
    		String newContents="<integer xmlns=\"http://example.com/loan-approval/xsd/error-messages/\">-100</integer>";
    		syEx.getMessage().setContent(newContents);
    	}
    }
 
}
